﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using System.IO;
using System.Text.RegularExpressions;
using System.Diagnostics;
using System.Windows.Forms;
using System.Speech.Synthesis;

namespace Simple_Bible_Reader
{
    class MP3BibleFormat : BibleFormat
    {
		int _book_no;

        public MP3BibleFormat(string file)
            : base(file)
		{
		}
		
		public override void Load()
		{
			// not supported!            
			//SetProcessAsComplete();
		}
		
		
		public override int PercentComplete
		{
			get
			{
				return ((_book_no) * 100) / 66;
			}
		}

        public override int FilterIndex
        {
            get
            {
                return F22_MP3;
            }
        }

        public override void ExportBible(string filename,int filter_idx)
        {            
            string path = this.FileName.Substring(0, this.FileName.LastIndexOf('.'));
            Directory.CreateDirectory(path);
            XmlNodeList books = BibleXmlDocument.SelectNodes("/XMLBIBLE/BIBLEBOOK");
            XmlNode vers = null;
            StringBuilder sb = new StringBuilder();

            for (int b = 1; b <= 66; b++)
            {
                _book_no = b;
                Directory.CreateDirectory(path+"\\"+Localization.getBookNames()[b-1]);
                
                for (int c = 1; c <= FormatUtil.GetChapterCount(b); c++)
                {
                    sb.Length = 0;
                    sb.Append(Localization.getBookNames()[b-1]+ ", Chapter " + c.ToString() + ". ");
                    for (int v = 1; v <= FormatUtil.GetVerseCount(b, c); v++)
                    {
                        vers = BibleXmlDocument.SelectSingleNode("/XMLBIBLE/BIBLEBOOK[@bnumber='" + b.ToString() + "']/CHAPTER[@cnumber='" + c.ToString() + "']/VERS[@vnumber='" + v.ToString() + "']");
                        if (vers != null)
                        {                            
                            sb.Append(vers.InnerText);
                            sb.Append(" ");
                        }
                    }
                    //
                    convertTextToMp3(sb.ToString(), path + "\\" + Localization.getBookNames()[b - 1]+"\\Chapter "+c.ToString()+".mp3");                                
                }                
            }                
        }

        SpeechSynthesizer speechSynthesizerObj = new SpeechSynthesizer();
        private void convertTextToMp3(string text, string mp3_file)
        {
            speechSynthesizerObj = new SpeechSynthesizer();

            using (SpeechSynthesizer synth = new SpeechSynthesizer())
            {
                synth.SetOutputToWaveFile(mp3_file);
                PromptBuilder builder = new PromptBuilder();
                builder.AppendText(text);
                synth.Speak(builder);                
            }
        }
    }
}
