using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.Diagnostics;

using System;
using System.Collections;
using System.Windows.Forms;
using System.Xml;
using System.Data.OleDb;
using System.Text.RegularExpressions;
using System.IO;
using System.Text;

namespace Simple_Bible_Reader
{
	public class TOPBookFormat : BookFormat
	{
		System.Xml.XmlElement rootdoc;
		System.Xml.XmlElement bookdoc;
		System.Xml.XmlAttribute attrib;


        string _title_text;
        string _notes_text;

        int percent_complete = 0;

        public string rtf_header = @"{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f1\fnil\fprq2\fcharset161 TITUS Cyberbit Basic;}{\f2\fnil\fprq2\fcharset177 TITUS Cyberbit Basic;}{\f3\fnil\fprq2\fcharset0 TITUS Cyberbit Basic;}{\f4\fnil\fprq2\fcharset136 PMingLiU;}{\f5\fnil\fprq2\fcharset204 Georgia;}{\f6\fnil\fprq2\fcharset238 Georgia;}{\f7\fnil\fprq2\fcharset134 PMingLiU;}{\f8\fnil\fprq2\fcharset222 Cordia New;}{\f9\fnil\fprq2\fcharset129 Gulim;}{\f10\fnil\fprq2\fcharset178 TITUS Cyberbit Basic;}{\f11\fnil\fprq2\fcharset162 Georgia;}{\f12\fnil\fprq2\fcharset163 Times New Roman;}{\f13\fnil\fprq2\fcharset128 MS Mincho;}}{\colortbl ;\red0\green0\blue0;\red0\green0\blue255;\red0\green255\blue255;\red0\green255\blue0;\red255\green0\blue255;\red255\green0\blue0;\red255\green255\blue0;\red255\green255\blue255;\red0\green0\blue128;\red0\green128\blue128;\red0\green128\blue0;\red128\green0\blue128;\red128\green0\blue0;\red128\green128\blue0;\red128\green128\blue128;\red192\green192\blue192;}{\viewkind4\uc1\pard\plain\cf0\fs\par}";
        public System.Windows.Forms.RichTextBox rtb = new System.Windows.Forms.RichTextBox();

		public TOPBookFormat(string file) : base(file)
		{
		}
		
		public override void Load()
		{
			BookXmlDocument = new System.Xml.XmlDocument();
			XmlDeclaration dec = BookXmlDocument.CreateXmlDeclaration("1.0", null, null);
			BookXmlDocument.AppendChild(dec);
			rootdoc = BookXmlDocument.CreateElement("XMLBOOK");
			BookXmlDocument.AppendChild(rootdoc);

            string[] default_password = Passwords.eSword8_Passwords;
			System.Data.OleDb.OleDbConnection conn = new System.Data.OleDb.OleDbConnection();
			bool bbl_open_success = false;
			
			foreach (string password in default_password)
			{
				try
				{
					conn.Close();
					conn = null;
					conn = new System.Data.OleDb.OleDbConnection();
                    OleDbConnectionStringBuilder builder = new OleDbConnectionStringBuilder();
					builder.Add("Provider", "Microsoft.Jet.Oledb.4.0");
					builder.Add("Jet OLEDB:Database Password", password);
					builder.Add("Data Source", FileName);
					conn.ConnectionString = builder.ConnectionString;
                    conn.Open();
					bbl_open_success = true;
					goto endOfForLoop;
				}
				catch (Exception)
				{
					continue;
				}
			}
endOfForLoop:
			
			if (! bbl_open_success)
			{
				conn.Close();
				SetProcessAsComplete();
				return;
			}
			
			DataSet ds = new DataSet();
			System.Data.OleDb.OleDbDataAdapter da;

            da = new System.Data.OleDb.OleDbDataAdapter("SELECT * FROM [Topic Notes] ORDER BY ID ASC", conn);
            da.Fill(ds, "Topic Notes");
            for (int i = 0; i <= ds.Tables["Topic Notes"].Rows.Count - 1; i++)
			{
                percent_complete = ((i) * 100) / ds.Tables["Topic Notes"].Rows.Count;
                _title_text = ds.Tables["Topic Notes"].Rows[i]["Title"].ToString();
                _notes_text = ds.Tables["Topic Notes"].Rows[i]["Comments"].ToString();
                _title_text = _title_text.Replace("&", "&amp;").Replace("<", "&lt;").Replace(">", "&gt;").Replace("\"", "&quot;").Replace("'", "&apos;");
                _notes_text = _notes_text.Replace("&", "&amp;").Replace("<", "&lt;").Replace(">", "&gt;").Replace("\"", "&quot;").Replace("'", "&apos;");
                processLine();				
			}
			conn.Close();
			SetProcessAsComplete();
		}


        private void processLine()
        {
            bookdoc = (XmlElement)BookXmlDocument.SelectSingleNode("/XMLBOOK/NOTES[@title='" + _title_text + "']");
            if (bookdoc == null)
            {
                bookdoc = BookXmlDocument.CreateElement("NOTES");
                attrib = BookXmlDocument.CreateAttribute("title");
                attrib.Value = _title_text.ToString();
                bookdoc.Attributes.Append(attrib);
                rootdoc.AppendChild(bookdoc);
            }
            bookdoc.InnerText = _notes_text;
        }	
		
		public override int PercentComplete
		{
			get
			{
                return percent_complete;
			}
		}

        public override int FilterIndex
        {
            get
            {
                return 3;
            }
        }

        public override void ExportBook(string filename, int filter_idx)
        {
            //ADOX.Catalog catNewDB = new ADOX.Catalog();

            if (!filename.EndsWith(".top"))
            {
                filename = filename + ".top";
            }
            if (filename.Equals(""))
            {
                return;
            }
            if(System.IO.File.Exists(filename))
                System.IO.File.Delete(filename);

            //catNewDB.Create("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + filename);
            File.WriteAllBytes(filename, Properties.Resources.db_mdb);
            OleDbConnection conn = new  OleDbConnection();
            OleDbConnectionStringBuilder builder = new OleDbConnectionStringBuilder();
			builder.Add("Provider", "Microsoft.Jet.Oledb.4.0");
			builder.Add("Jet OLEDB:Database Password", "");
			builder.Add("Data Source", FileName);
			conn.ConnectionString = builder.ConnectionString;            
            conn.Open();
            // Bible Table
            OleDbCommand cmd = new OleDbCommand("CREATE TABLE [Topic Notes] (ID AUTOINCREMENT,Title VARCHAR(50),Comments TEXT)", conn);
            cmd.ExecuteNonQuery();

            XmlNodeList titles = BookXmlDocument.SelectNodes("/XMLBOOK/NOTES/@title");
            XmlNode note = null;
            int ctr = 1;
            string _note_text = "";
            for (int i = 0; i < titles.Count; i++)
            {
                percent_complete = i * 100 / titles.Count;

                note = BookXmlDocument.SelectSingleNode("/XMLBOOK/NOTES[@title='" + titles[i].Value + "']");
                if (note != null)
                {
                    _note_text = note.InnerText.Replace("\n","\\par");
                    byte[] bytes = Encoding.UTF8.GetBytes(_note_text);
                    cmd = new OleDbCommand("INSERT INTO [Topic Notes] (Title,Comments) VALUES('" + titles[i].Value.Replace("'", "''") + "','" + rtf_header+_note_text.Replace("'", "''") + " }')", conn);
                    cmd.ExecuteNonQuery();
                    ctr++;
                }
            }
            conn.Close();
        }
    }
}
