﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;

namespace Simple_Bible_Reader
{
    public class GlobalMemory
    {
        bool dev_mode = false;

        public const string AUTHOR_WEBSITE = "trumpet-call.org/simplebiblereader/";

        static GlobalMemory _gm = null;

        public const int DIRECTION_LTR = 0;
        public const int DIRECTION_RTL = 1;        

        int _dir = 0;

        string font_size_bib = "x-small";
        public int FONT_SIZE_IDX_BIB = 1;

        string font_size_cmt = "x-small";
        public int FONT_SIZE_IDX_CMT = 1;

        string font_size_dict = "x-small";
        public int FONT_SIZE_IDX_DICT = 1;

        string font_family_bib = "";
        string font_family_cmt = "";
        string font_family_dct = "";

        public string Locale = "en";
       
        bool transliterate = false;

        public bool ParseBible = true;
        public bool parseBibleBkgndCleaner = false;

        public bool ParseCmtry = true;
        public bool ParseDict = true;
        
        public bool ParseBook = true;
        public bool parseBookBkgndCleaner = true;

        public int Mp3Volume = 90;
        public int Mp3Speed = -2;
        public int Mp3VoiceIndex = 0;
        public bool Mp3Transliterate = false;

        public bool CommentaryIcon = true;

        public bool addRedText = false;

        public bool EnablePlugins = false;

        public bool ConsoleMode = false;


        public bool ConvertRtfToHtmlBible = false;
        public bool ConvertRtfToHtmlCommentary = false;
        public bool ConvertRtfToHtmlDictionary = false;
        public bool ConvertRtfToHtmlBook = false;

        public ArrayList PluginsList = new ArrayList();

        public static GlobalMemory getInstance()
        {
            if (_gm == null)
                _gm = new GlobalMemory();
            return _gm;
        }

        public bool DevMode
        {
            get
            {
                return dev_mode;
            }
            set
            {
                dev_mode = value;
            }
        }

        public bool Transliteration
        {
            get
            {
                return transliterate;
            }
            set
            {
                transliterate = value;
            }
        }

        public int Direction
        {
            get
            {
                return _dir;
            }
            set
            {
                _dir = value;
            }
        }

        public string FontSizeBIB
        {
            get
            {
                return font_size_bib;
            }
            set
            {
                font_size_bib = value;
            }
        }

        public string FontSizeCMT
        {
            get
            {
                return font_size_cmt;
            }
            set
            {
                font_size_cmt = value;
            }
        }

        public string FontSizeDICT
        {
            get
            {
                return font_size_dict;
            }
            set
            {
                font_size_dict = value;
            }
        }

        public string FontFamilyBIB
        {
            get
            {
                return font_family_bib;
            }
            set
            {
                font_family_bib = value;
            }
        }

        public string FontFamilyCMT
        {
            get
            {
                return font_family_cmt;
            }
            set
            {
                font_family_cmt = value;
            }
        }

        public string FontFamilyDICT
        {
            get
            {
                return font_family_dct;
            }
            set
            {
                font_family_dct = value;
            }
        }

        public static string changeReleaseHtml()
        {
            StringBuilder relnotes = new StringBuilder();
            relnotes.Append("<html><head>");
            relnotes.Append(BibleFormat.CSS_English);
            relnotes.Append("</head><body>");

            /*
            relnotes.Append("<i><b>Pending / Identified Issues</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li></li>");
            relnotes.Append("</ul></i>");
            */

            relnotes.Append("<b>Release Notes - 5.2</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Apocrypha support for Zefania XML Bile, MyBible, e-Sword</li>");
            relnotes.Append("<li>Several bug fixes and code improvements</li>");
            relnotes.Append("<li>Background cleaning disabled by default</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 5.1</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Support for e-Sword HD dcti and refi format.</li>");
            relnotes.Append("<li>Support for The Sword Project raw display/export.</li>");
            relnotes.Append("<li>Books missing in BibleAnalyzer export fixed.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 5.0</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Added third-party licenses.</li>");
            relnotes.Append("<li>Minor code modification.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 4.4</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Portuguese Translation</li>");
            relnotes.Append("<li>Minor Bugfix</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 4.3</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Support for e-Sword HD CMTI format.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 4.2</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Updated UI with better toolbar icons</li>");
            relnotes.Append("<li>Bugfix on plugin processing.</li>");
            relnotes.Append("<li>A Bible reader with no Bible content? The Gospel of John from WEB translation added.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 4.1</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Fixed export issue while parsing disabeld</li>");
            relnotes.Append("<li>Improved plugin support.</li>");
            relnotes.Append("<li>Updated icon with better resolution.</li>");
            relnotes.Append("<li>Updated links and several internal improvements.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 4.0</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>DPI awareness for high resolutions.</li>");
            relnotes.Append("<li>Fixed print issue.</li>");
            relnotes.Append("<li>Support for MyBible format.</li>");
            relnotes.Append("<li>Support e-Sword BBLI format.</li>");
            relnotes.Append("<li>Support SwordSearcher format.</li>");
            relnotes.Append("<li>Rtf to Html for better display.</li>");
            relnotes.Append("<li>Updated links and several internal improvements.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 3.0</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Support for Windows 10.</li>");
            relnotes.Append("<li>Executable Bible removed.</li>");
            relnotes.Append("<li>Updated links.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 2.9</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Support for VerseVIEW Bible format.</li>");
            relnotes.Append("<li>Export to theWord gives some html escaed chars - fixed.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 2.8</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Support for HeavenWorld Bible format.</li>");
            relnotes.Append("<li>Support for OnlineBible Book format.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 2.7</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Support for Palm Bible+ format.</li>");
            relnotes.Append("<li>Red-text simulation not enabled by default (can be enabled from Preferences) to avoid interfering with modules that already have red text.</li>");
            relnotes.Append("<li>Support for OnlineBible Commentary and Dictionary formats. Export to OnlineBible dictionaries not supported.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 2.6</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Context menu on red text doesn't work - fixed.</li>");
            relnotes.Append("<li>Support for OnlineBible format.</li>");
            relnotes.Append("<li>Supports red-text for MySword for Android.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 2.5</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>GoBible suddenly doesn't open - fixed.</li>");
            relnotes.Append("<li>Introducing plugins based on regular expressions.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 2.4</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Optional Chapter Titles</li>");
            relnotes.Append("<li>A few theWord dictionaries give error System.Byte[] - fixed.</li>");
            relnotes.Append("<li>GoBible NT gives Book names from Gen to Dan - fixed.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 2.3</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Rebuilt using Microsoft .Net 2.0. Supports Windows 8</li>");
            relnotes.Append("<li>Automatically convert Christ's Words to Red Text.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 2.2</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Split into two versions - A new version that supports Windows 8 (Requires .Net 4.0+) and a legacy version that supports from Windows XP to Windows 7 (Requires .Net 2.0+). The two versions will continue to co-exist temporarily until a single portable version is feasible to support all platforms including Windows 8.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 2.1</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li><i>(Note: Version 2.0 withdrawn and re-released as 2.1 on the same day after an important bug fix)</i></li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 2.0</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Minimum Requirement changed to Microsoft .Net 4.0 to support Windows 8.</li>");
            relnotes.Append("<li>Speak verse/chapter in context menu of reading pane to hear the Bible being read in background</li>");
            relnotes.Append("<li>Unable to export if the import file contains a single quote - Fixed</li>");
            relnotes.Append("<li>Support for e-Sword Reference Libraries (.refx files).</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 1.23</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Console based parameters are now available. It enables Simple Bible Reader to be silently used/or called from another programs.</li>");
            relnotes.Append("<li>Localizations are now autodetected and autoenabled</li>");
            relnotes.Append("<li>Localizations in Spanish - Thanks to Julio Behr</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 1.22</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Exported Unbound Bibles not able to open in 'The Unbound Bible Tools' - fixed</li>");
            relnotes.Append("<li>Experimental localization in Tamil. More languages will be added soon.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 1.21</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>TOPX with qoutes in titles displays System.Byte [] - fixed.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 1.20</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Some files previously worked suddenly failed to load - fixed.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 1.19</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Bibles exportable to LOGOS Import (docx) format.</li>");
            relnotes.Append("<li>Convert massive amount of files using batch mode.</li>");
            relnotes.Append("<li>Support for user plugins to hook into the parsing process.</li>");
            relnotes.Append("<li>Application digitally signed using trusted CA.</li>");
            relnotes.Append("<li>Greek/Hebrew letters not displayed properly in some formats- fixed.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 1.18</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Bug fix for drag and drop of non-Bibles</li>");
            relnotes.Append("<li>Preference page for MP3 Bible files.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 1.17</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Support for EasySlides Bibles.</li>");
            relnotes.Append("<li>Export English Bibles as MP3 files.</li>");
            relnotes.Append("<li>Export progress bar at 100% always - fixed.</li>");
            relnotes.Append("<li>Printer exception - fixed.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 1.16</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Support for STEP modules but export not yet fully supported.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 1.15</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Bug fix - Can't open theWord commentary modules from wordmodules.com</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 1.14</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Bug fix - The Word format export collapses when verses have multiple lines.</li>");
            relnotes.Append("<li>Bug fix - Some red texts disappears in e-Sword because of nested rtf tags.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 1.13</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Option to unencrypt while export of e-Sword 9.x Bibles in Preferences for the support of editing Bibles using ToolTip Tool NT.</li>");
            relnotes.Append("<li>VPL format now supports Strong's</li>");
            relnotes.Append("<li>Minor Bug-fix on MySword for Android dictionary export.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 1.12</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Support for the SWORD Project Books.</li>");
            relnotes.Append("<li>Support for the BibleAnalyzer Books.</li>");
            relnotes.Append("<li>Support for the MySword for Android Books.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 1.11</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Support for e-Sword Topics and The Word Books.</li>");
            relnotes.Append("<li>Better text support for RVF based The Word modules.</li>");
            relnotes.Append("<li>Encrypting e-Sword modules during export.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 1.10</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Support for BibleAnalyzer commentaries and dictionaries.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 1.9</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Support for MySword for Android commentaries and dictionaries.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 1.8</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Extended ASCII characters are displayed as squares - fixed</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 1.7</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>You know a language to speak but doesn't know how to read or write? Don't worry. Transliteration support is now added.</li>");
            relnotes.Append("<li>Bible Statistics.</li>");
            relnotes.Append("<li>Unicode Bug introduced in 1.6 - Fixed.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 1.6</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>SWORD Dictionary - Bug fixed. Now supports compressed SWORD dictionaries.</li>");
            relnotes.Append("<li>Export parameters like abbrevation, description, comments does not work - fixed.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 1.5</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Executable Bible now has same advanced features as Simple Bible Reader</li>");
            relnotes.Append("<li>Ability to automatically detect file format with support for drag-and-drop of any supported format irrespective of bibles, commentaries and dictionaries.</li>");
            relnotes.Append("<li>Supports SWORD Dictionaries.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 1.4</b>");
            relnotes.Append("<ul>");
            relnotes.Append("<li>Layout changes along with advanced layout options to support commentary and dictionary. </li>");
            relnotes.Append("<li>Option to change fonts.</li>");
            relnotes.Append("<li>Paragraph view</li>");
            relnotes.Append("<li>Support for red-text and lexicon display for Zefania XML, e-Sword and The Word modules.</li>");
            relnotes.Append("<li>Support for XML, SWORD, e-Sword and The Word commentaries.</li>");
            relnotes.Append("<li>Support for Zefania, e-Sword and TheWord Dictionary modules.</li>");
            relnotes.Append("<li>Advanced search support with and, or, exact, match case and regular expressions.</li>");
            relnotes.Append("<li>Linking Bible verse to Commentaries and lexicon-dictionary.</li>");
            relnotes.Append("</ul>");

            relnotes.Append("<b>Release Notes - 1.3</b>");
            relnotes.Append("<ul><li>Compressed SWORD Bibles of OSIS SourceType doesn't open - Fixed.</li></ul>");

            relnotes.Append("<b>Release Notes - 1.2</b>");
            relnotes.Append("<ul><li>Support for The Word encrypted modules - .ontx, .otx and .ntx</li></ul>");

            relnotes.Append("<b>Release Notes - 1.1</b>");
            relnotes.Append("<ul><li>Support for MySword for Android bibles</li><li>Support for Bible Analyzer bibles</li></ul>");

            relnotes.Append("<b>Release Notes - 1.0</b>");
            relnotes.Append("<ul><li>Initial Release.</li><li>Supports nearly 20 bible formats.</li></ul>");

            relnotes.Append("</body></html>");
            return relnotes.ToString();
        }

        public static string CSS_MainScreenDisplay
        {
            get
            {
                StringBuilder sb = new StringBuilder();

                sb.Append("<style type=\'text/css\'>");
                sb.Append("body { ");
                sb.Append("  font-family: \"Palatino Linotype\", \"Book Antiqua\", Palatino, serif;");
                sb.Append("  font-size: "+ GlobalMemory.getInstance().FontSizeBIB + ";");
                sb.Append("}");

                sb.Append("td { ");
                sb.Append("  font-family: \"Palatino Linotype\", \"Book Antiqua\", Palatino, serif;");
                sb.Append("  font-size: " + GlobalMemory.getInstance().FontSizeBIB + "; ");
                sb.Append("}");

                sb.Append("a {");
                sb.Append("background: white none repeat scroll 0 0;");
                sb.Append("color: black;");
                sb.Append("outline: medium none;");
                //sb.Append("padding: 15px;");
                sb.Append("text-decoration: none;");
                sb.Append("}");

                sb.Append("a:hover {");
                sb.Append("background-color: grey;");
                sb.Append("color: white;");
                sb.Append("cursor: default;");
                sb.Append("}");

                sb.Append("#bgimage {");
                sb.Append("margin: 1em 20px;");
                sb.Append("padding-left: 30px;");
                sb.Append("background: transparent url(data:image/gif;base64," + Properties.Resources.quote_gif + ") no-repeat; }");

                sb.Append("</style>");

                return sb.ToString();

            }
        }
    }
}
