﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;

namespace Simple_Bible_Reader
{
    public partial class PluginsFrm : Form
    {
        OpenFileDialog ofd = null;

        public PluginsFrm()
        {
            InitializeComponent();
        }

        private void cbEnablePlugins_CheckedChanged(object sender, EventArgs e)
        {
            GlobalMemory.getInstance().EnablePlugins = cbEnablePlugins.Checked;
            dgvPlugins.Enabled = cbEnablePlugins.Checked;
            SimpleBibleReader.getInstance().pluginsToolStripMenuItem.Checked = cbEnablePlugins.Checked;
            
        }

        private void PluginsFrm_Load(object sender, EventArgs e)
        {
            cbEnablePlugins.Checked = GlobalMemory.getInstance().EnablePlugins;
            if (ofd == null)
            {
                ofd = new OpenFileDialog();
                ofd.Filter = "Regex Plugin|*.rxp|All files|*.*";
            }

        }

        private void deletePluginToolStripMenuItem_Click(object sender, EventArgs e)
        {
            dgvPlugins.Rows.Remove(dgvPlugins.CurrentRow);
        }

        private void dgvPlugins_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {            
            if (e.ColumnIndex == 2)
            {
                if (ofd.ShowDialog(this) == DialogResult.OK)
                {
                    dgvPlugins.CurrentRow.Cells[1].Value = ofd.FileName;
                }
            }
        }

        private void PluginsFrm_FormClosing(object sender, FormClosingEventArgs e)
        {
            GlobalMemory.getInstance().PluginsList.Clear();
            for (int i = 0; i < dgvPlugins.Rows.Count; i++)
            {
                if ((string)dgvPlugins.Rows[i].Cells[0].Value == "true")
                {
                    GlobalMemory.getInstance().PluginsList.Add((string)dgvPlugins.Rows[i].Cells[1].Value);                   
                }
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            MessageBox.Show(Localization.MainPage_PluginHelpText, "Plugin Help", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            Process.Start("https://trumpet-call.org/sbr-plugins/");
        }
    }
}
