﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;

namespace Simple_Bible_Reader
{
    public partial class PreferencesFrm : Form
    {
        public PreferencesFrm()
        {
            InitializeComponent();
        }

        private void Cancel_Click(object sender, EventArgs e)
        {
            this.Visible = false;
        }

        private void OK_Click(object sender, EventArgs e)
        {
            GlobalMemory.getInstance().ParseBible = rbBibleParse.Checked;
            GlobalMemory.getInstance().parseBibleBkgndCleaner = cbBibleBkgndCleaning.Checked;
            GlobalMemory.getInstance().addRedText = cbBibleRedText.Checked;
            //
            GlobalMemory.getInstance().ParseBook = rbBookParse.Checked;
            GlobalMemory.getInstance().parseBookBkgndCleaner = cbBookBkgndCleaning.Checked;
            //
            GlobalMemory.getInstance().ParseCmtry = rbCmtryParse.Checked;
            //
            GlobalMemory.getInstance().ParseDict = rbDictParse.Checked;
            GlobalMemory.getInstance().CommentaryIcon = cbBibleCmtryIcon.Checked;

            GlobalMemory.getInstance().Mp3Volume = tbMp3Volume.Value;
            GlobalMemory.getInstance().Mp3Speed = tbMP3Speed.Value;

            GlobalMemory.getInstance().Mp3VoiceIndex = cbMp3Voices.SelectedIndex;
            GlobalMemory.getInstance().Mp3Transliterate = cbMp3Transliterate.Checked;

            //
            GlobalMemory.getInstance().ConvertRtfToHtmlBible = cbBibleRtfToHtml.Checked;
            GlobalMemory.getInstance().ConvertRtfToHtmlCommentary = cbCommentaryRtfToHtml.Checked;
            GlobalMemory.getInstance().ConvertRtfToHtmlDictionary = cbDictionaryRtfToHtml.Checked;
            GlobalMemory.getInstance().ConvertRtfToHtmlBook = cbBookRtfToHtml.Checked;

            this.Visible = false;
        }

        private void PreferencesFrm_Load(object sender, EventArgs e)
        {
            rbBibleParse.Checked = GlobalMemory.getInstance().ParseBible;
            cbBibleBkgndCleaning.Checked = GlobalMemory.getInstance().parseBibleBkgndCleaner;
            rbBookParse.Checked = GlobalMemory.getInstance().ParseBook;
            cbBookBkgndCleaning.Checked = GlobalMemory.getInstance().parseBookBkgndCleaner;
            cbBibleRedText.Checked = GlobalMemory.getInstance().addRedText;
            rbCmtryParse.Checked = GlobalMemory.getInstance().ParseCmtry;
            rbDictParse.Checked = GlobalMemory.getInstance().ParseDict;
            cbBibleCmtryIcon.Checked = GlobalMemory.getInstance().CommentaryIcon;
            tbMp3Volume.Value = GlobalMemory.getInstance().Mp3Volume;
            tbMP3Speed.Value = GlobalMemory.getInstance().Mp3Speed;
            //
            SpeechLib.SpVoice oVoice = new SpeechLib.SpVoice();

            SpeechLib.ISpeechObjectTokens tokens = oVoice.GetVoices();
            cbMp3Voices.Items.Clear();
            foreach (SpeechLib.ISpeechObjectToken token in tokens)
            {
                cbMp3Voices.Items.Add(token.GetDescription());
            }
            cbMp3Voices.SelectedIndex = GlobalMemory.getInstance().Mp3VoiceIndex;
            cbMp3Transliterate.Checked = GlobalMemory.getInstance().Mp3Transliterate;
        }

        private void rbBibleParse_CheckedChanged(object sender, EventArgs e)
        {
            cbBibleBkgndCleaning.Checked = rbBibleParse.Checked;
            cbBibleBkgndCleaning.Enabled = rbBibleParse.Checked;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //
            SpeechLib.SpVoice oVoice = new SpeechLib.SpVoice();
            oVoice.Volume = tbMp3Volume.Value;
            oVoice.Rate = tbMP3Speed.Value;
            oVoice.Voice = oVoice.GetVoices().Item(cbMp3Voices.SelectedIndex);
            if(cbMp3Transliterate.Checked)
                oVoice.Speak(Unidecoder.Unidecode(tbMp3Text.Text), SpeechLib.SpeechVoiceSpeakFlags.SVSFDefault);
            else
                oVoice.Speak(tbMp3Text.Text, SpeechLib.SpeechVoiceSpeakFlags.SVSFDefault);
            oVoice = null;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            MessageBox.Show("There are many third-party high quality voices.You can install them seperately based on your needs.", "Voices", MessageBoxButtons.YesNo, MessageBoxIcon.Question);           
        }
    }
}
